setup-ipsec-vpn/extras/vpnupgrade_centos.sh

174 lines
4.9 KiB
Bash
Raw Normal View History

2016-01-08 10:03:56 +01:00
#!/bin/sh
#
2016-04-21 00:31:29 +02:00
# Script to upgrade Libreswan on CentOS and RHEL
2016-01-08 10:03:56 +01:00
#
2017-01-17 05:13:13 +01:00
# Copyright (C) 2016-2017 Lin Song <linsongui@gmail.com>
2016-01-08 10:03:56 +01:00
#
# This work is licensed under the Creative Commons Attribution-ShareAlike 3.0
# Unported License: http://creativecommons.org/licenses/by-sa/3.0/
#
# Attribution required: please include my name in any derivative and let me
# know how you have improved it!
2016-07-20 20:10:58 +02:00
# Check https://libreswan.org for the latest version
swan_ver=3.20
2016-01-08 10:03:56 +01:00
2016-11-07 02:30:53 +01:00
### DO NOT edit below this line ###
2016-01-21 18:50:35 +01:00
export PATH="/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin"
2016-11-07 02:30:53 +01:00
exiterr() { echo "Error: $1" >&2; exit 1; }
2016-07-04 00:54:15 +02:00
exiterr2() { echo "Error: 'yum install' failed." >&2; exit 1; }
if ! grep -qs -e "release 6" -e "release 7" /etc/redhat-release; then
2016-06-29 09:40:52 +02:00
exiterr "This script only supports CentOS/RHEL 6 and 7."
2016-01-08 10:03:56 +01:00
fi
2016-01-30 20:12:15 +01:00
if [ -f /proc/user_beancounters ]; then
2016-06-29 09:40:52 +02:00
exiterr "This script does not support OpenVZ VPS."
2016-01-19 08:32:22 +01:00
fi
2016-01-08 10:03:56 +01:00
if [ "$(id -u)" != 0 ]; then
2016-06-29 09:40:52 +02:00
exiterr "Script must be run as root. Try 'sudo sh $0'"
2016-01-08 10:03:56 +01:00
fi
2016-06-21 05:35:45 +02:00
if [ -z "$swan_ver" ]; then
2016-06-29 09:40:52 +02:00
exiterr "Libreswan version 'swan_ver' not specified."
2016-06-21 05:35:45 +02:00
fi
2017-05-22 18:46:28 +02:00
if ! /usr/local/sbin/ipsec --version 2>/dev/null | grep -q "Libreswan"; then
2016-06-29 09:40:52 +02:00
exiterr "This script requires Libreswan already installed."
2016-01-08 10:03:56 +01:00
fi
2017-05-22 18:46:28 +02:00
if /usr/local/sbin/ipsec --version 2>/dev/null | grep -qF "$swan_ver"; then
2016-06-21 05:35:45 +02:00
echo "You already have Libreswan version $swan_ver installed! "
echo "If you continue, the same version will be re-installed."
2016-01-08 10:03:56 +01:00
echo
printf "Do you wish to continue anyway? [y/N] "
read -r response
2016-01-08 10:03:56 +01:00
case $response in
[yY][eE][sS]|[yY])
echo
;;
*)
echo "Aborting."
exit 1
;;
esac
fi
2016-01-18 19:37:09 +01:00
clear
2016-05-21 10:59:08 +02:00
cat <<EOF
2016-06-21 05:35:45 +02:00
Welcome! This script will build and install Libreswan $swan_ver on your server.
2016-05-21 10:59:08 +02:00
Additional packages required for Libreswan compilation will also be installed.
This is intended for use on servers running an older version of Libreswan.
EOF
cat <<'EOF'
IMPORTANT NOTES:
Libreswan versions 3.19 and newer require some configuration changes.
This script will make the following changes to your /etc/ipsec.conf:
Replace this line:
auth=esp
with the following:
phase2=esp
Replace this line:
forceencaps=yes
with the following:
encapsulation=yes
Consolidate VPN ciphers for "ike=" and "phase2alg=".
Re-add "MODP1024" to the list of allowed "ike=" ciphers,
which was removed from the defaults in Libreswan 3.19.
Your other VPN configuration files will not be modified.
2016-05-21 10:59:08 +02:00
EOF
2016-01-08 10:03:56 +01:00
printf "Do you wish to continue? [y/N] "
read -r response
2016-01-08 10:03:56 +01:00
case $response in
[yY][eE][sS]|[yY])
echo
echo "Please be patient. Setup is continuing..."
echo
;;
*)
echo "Aborting."
exit 1
;;
esac
# Create and change to working dir
mkdir -p /opt/src
2016-06-29 09:40:52 +02:00
cd /opt/src || exiterr "Cannot enter /opt/src."
2016-01-08 10:03:56 +01:00
2016-01-21 18:50:35 +01:00
# Install Wget
2016-07-04 00:54:15 +02:00
yum -y install wget || exiterr2
2016-01-08 10:03:56 +01:00
# Add the EPEL repository
2016-07-04 00:54:15 +02:00
yum -y install epel-release || exiterr2
2016-01-08 10:03:56 +01:00
# Install necessary packages
yum -y install nss-devel nspr-devel pkgconfig pam-devel \
2016-07-10 08:36:41 +02:00
libcap-ng-devel libselinux-devel \
curl-devel flex bison gcc make \
fipscheck-devel unbound-devel xmlto || exiterr2
2016-01-08 10:03:56 +01:00
2016-08-07 21:00:07 +02:00
# Install libevent2 and systemd-devel
2016-01-08 10:03:56 +01:00
if grep -qs "release 6" /etc/redhat-release; then
yum -y remove libevent-devel
2016-07-04 00:54:15 +02:00
yum -y install libevent2-devel || exiterr2
else
2016-07-04 00:54:15 +02:00
yum -y install libevent-devel systemd-devel || exiterr2
2016-01-08 10:03:56 +01:00
fi
# Compile and install Libreswan
2016-07-10 08:36:41 +02:00
swan_file="libreswan-$swan_ver.tar.gz"
swan_url1="https://github.com/libreswan/libreswan/archive/v$swan_ver.tar.gz"
swan_url2="https://download.libreswan.org/$swan_file"
2016-10-11 05:34:51 +02:00
if ! { wget -t 3 -T 30 -nv -O "$swan_file" "$swan_url1" || wget -t 3 -T 30 -nv -O "$swan_file" "$swan_url2"; }; then
exiterr "Cannot download Libreswan source."
fi
2016-06-21 05:35:45 +02:00
/bin/rm -rf "/opt/src/libreswan-$swan_ver"
2016-05-21 12:34:19 +02:00
tar xzf "$swan_file" && /bin/rm -f "$swan_file"
2016-06-29 09:40:52 +02:00
cd "libreswan-$swan_ver" || exiterr "Cannot enter Libreswan source dir."
echo "WERROR_CFLAGS =" > Makefile.inc.local
2016-05-17 05:42:30 +02:00
make -s programs && make -s install
2016-01-08 10:03:56 +01:00
2016-06-04 00:10:03 +02:00
# Verify the install and clean up
2016-06-29 09:40:52 +02:00
cd /opt/src || exiterr "Cannot enter /opt/src."
2016-06-21 05:35:45 +02:00
/bin/rm -rf "/opt/src/libreswan-$swan_ver"
2017-05-22 18:46:28 +02:00
if ! /usr/local/sbin/ipsec --version 2>/dev/null | grep -qF "$swan_ver"; then
2016-10-11 05:34:51 +02:00
exiterr "Libreswan $swan_ver failed to build."
fi
2016-06-04 00:10:03 +02:00
# Restore SELinux contexts
2016-04-21 00:31:29 +02:00
restorecon /etc/ipsec.d/*db 2>/dev/null
restorecon /usr/local/sbin -Rv 2>/dev/null
restorecon /usr/local/libexec/ipsec -Rv 2>/dev/null
# Update ipsec.conf for Libreswan 3.19 and newer
IKE_NEW=" ike=3des-sha1,3des-sha2,aes-sha1,aes-sha1;modp1024,aes-sha2,aes-sha2;modp1024,aes256-sha2_512"
PHASE2_NEW=" phase2alg=3des-sha1,3des-sha2,aes-sha1,aes-sha2,aes256-sha2_512"
sed -i".old-$(date +%Y-%m-%d-%H:%M:%S)" \
-e "s/^[[:space:]]\+auth=esp\$/ phase2=esp/" \
-e "s/^[[:space:]]\+forceencaps=yes\$/ encapsulation=yes/" \
-e "s/^[[:space:]]\+ike=.\+\$/$IKE_NEW/" \
-e "s/^[[:space:]]\+phase2alg=.\+\$/$PHASE2_NEW/" /etc/ipsec.conf
2016-01-20 06:17:18 +01:00
# Restart IPsec service
2016-04-21 00:31:29 +02:00
service ipsec restart
2016-01-08 10:03:56 +01:00
echo
2016-06-21 05:35:45 +02:00
echo "Libreswan $swan_ver was installed successfully! "
2016-04-21 00:31:29 +02:00
echo
2016-05-21 10:59:08 +02:00
2016-01-08 10:03:56 +01:00
exit 0